;===============================================================================
;  SD2003A VER1.0
;    ڲʵʱʱSD2003A
;    £
;    1. ر/INT1/INT2ж
;    2. ʼʱ(дʱ)
;    3. BREAKPOINT1ϵʱ,ʱѭ
;    4. ȫִʱ,LEDλֱʾСʱͷӵֵ
;
;       ע: ƬAT89C51⾧Ϊ12Mhz,˾SD2003A
;       Last update:2003/06/13
;       οϵ¹ 0755-83246178,83220794,fax:83225561
;       13922865036   chendw@whwave.com.cn  http://www.whwave.com.cn
;===============================================================================
;define the general register
;ʱĴ
        YEAR    EQU     20H             ;
        MONTH   EQU     21H             ;
        DAY     EQU     22H             ;
        DATE    EQU     23H             ;
        HOUR    EQU     24H             ;Сʱ
        MINUTE  EQU     25H             ;
        SECOND  EQU     26H             ;
        FLAG    EQU     27H             ;ͨñ־Ĵ
                                        ;BIT0=1, ACK ERR
                                        ;BIT0=0 ,ACK OK

;LEDʾĴ
	DATA_SEG EQU	40H		;ʾݼĴ
        DIS_REG EQU     41H             ;ʾλüĴ:1-4
        STACK_A EQU     42H             ;ʾжʱAĻ

;ƬʵʱʱӼͨżĴ
        TIMETEMP        EQU     2FH     ;ʱ־Ĵ
        TIMETX          EQU     47H     ;ʱݷͼĴ
        TIMERX          EQU     48H     ;ʱݽռĴ


;---------------------------------------------------------------------------
;define port bit
;ͨſλ
        SDA     EQU     P3.4            ;IICSDA
        SCL     EQU     P3.5            ;IICSCL

;===========================================================================

        ORG     0000H                   ;RESET
        LJMP    START
        ORG     000BH
        LJMP    LED_DISPLAY             ;T0ж
;---------------------------------------------------------------------------

        ORG     0100H
START:
        CLR     A                       ;ʼʼĴ
        MOV     IE,A                    ;ж
        MOV     P1,A
        MOV     P2,A                    ;PORT1,PORT20
        MOV     P3,#0FFH                ;PORT31
        MOV     SP,#60H                 ;ջ
        MOV     TMOD,#01H               ;ʱ0Ϊ16λʱ
        MOV     TH0,#0F0H               ;жΪ4096us
        MOV     TL0,#0H                 ;
        MOV     DIS_REG,#00H            ;
        CLR     FLAG                    ;־λ
        LCALL   LONGDELAY               ;ʱ300ms
        LCALL   LONGDELAY               ;ʱ300ms
        LCALL   TIMESTATUS_INT12        ;SD2003Aʱ״̬Ĵ
        SETB    EA                      ;AT89C51ж
        SETB    TR0                     ;T0ʼ

INTI_TIME:
	MOV	YEAR,#02H	        ;趨ʱĴʼʱ
	MOV	MONTH,#07H
	MOV	DAY,#15H
	MOV	DATE,#01H
	MOV	HOUR,#17H
	MOV	MINUTE,#59H
	MOV	SECOND,#50H
        CLR     ET0                     ;رAT89C51TIME0ж
        LCALL   WRITE_TIME              ;ʼʱֵдʱ
        SETB    ET0                     ;AT89C51TIME0ж
;-----------------------------------------------------------------
GET_TIME:
        CLR     ET0                     ;رAT89C51TIME0ж
        LCALL   READ_TIME               ;SD2003Aڵʵʱʱ
        SETB    ET0                     ;AT89C51TIME0ж
BREAKPOINT1:    NOP                     ;ϵ
        LCALL   LONGDELAY               ;ʱ300ms,ĳ
	JMP	GET_TIME

;=======================ʱ/жӳ==============================
;ܣλLEDʾ                                                |
;ڣʾDATA1DATA2DATA3DATA4                             |
;ڣNONE                                                               |
;ӰԴATEMPP1P3,PSW                                            |
;==========================================================================
LED_DISPLAY:
        MOV     STACK_A,A
        CLR     EA                        ;ж
COMPARE:
        MOV     A,DIS_REG
        CJNE    A,#01H,COM1
        JMP     DISBIT1
COM1:
        CJNE    A,#02H,COM2
        JMP     DISBIT2
COM2:
        CJNE    A,#03H,COM3
        JMP     DISBIT3
COM3:
        MOV     DIS_REG,#00H
        JMP     DISBIT4
DISBIT1:
	MOV	A,HOUR
	SWAP	A
	ANL	A,#0FH
	MOV	DATA_SEG,A
        MOV     A,#0FFH
        MOV     P3,A
	MOV	A,DATA_SEG
	MOV	DPTR,#TABLE
	MOVC	A,@A+DPTR		;ȡ
	MOV	P1,A
	CLR	P3.0			;ʾһλ
        LJMP    DISEND
DISBIT2:
        MOV	A,HOUR                  ;Сʱ
	ANL	A,#0FH
	MOV	DATA_SEG,A
        MOV     A,#0FFH
        MOV     P3,A
	MOV	A,DATA_SEG
	MOV	DPTR,#TABLE
	MOVC	A,@A+DPTR
	MOV	P1,A
        MOV     C,SECOND.0              ;˸
        MOV     P1.7,C
	CLR	P3.1			;ʾڶλ
        LJMP    DISEND
DISBIT3:
	MOV	A,MINUTE
	SWAP	A
	ANL	A,#0FH
	MOV     DATA_SEG,A
        MOV     A,#0FFH
        MOV     P3,A
	MOV	A,DATA_SEG
	MOV	DPTR,#TABLE
	MOVC	A,@A+DPTR
	MOV	P1,A
	CLR	P3.2			;ʾλ
        LJMP    DISEND
DISBIT4:
	MOV	A,MINUTE                ;ʾ
	ANL	A,#0FH
	MOV	DATA_SEG,A
        MOV     A,#0FFH
        MOV     P3,A
	MOV	A,DATA_SEG
	MOV	DPTR,#TABLE
	MOVC	A,@A+DPTR
	MOV	P1,A
	CLR	P3.3			;ʾλ
DISEND:
        INC     DIS_REG
        MOV	TH0,#0F0H		;װʱ0ֵ
	MOV	TL0,#000H               ;
        SETB    EA                      ;ж
        MOV     A,STACK_A
        RETI
TABLE:  DB      0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H
        DB      80H,90H,88H,83H,0A7H,0A1H,86H,8EH

;==================ʵʱʱʵʱݼĴӳ==========================
;ܣʵʱʱӶ뵱ǰʱ                                         |
;ڣNONE                                                               |
;ڣݷꡢ¡աڡʱ֡Ĵ                   |
;ӰԴAR0,R3,TIMETX,TIMERX,YEAR,MONTH,DAY,WEEK,HOUR,MINUTE,SECOND  |
;==========================================================================
READ_TIME:
	LCALL	IICSTART
        JB      FLAG.1,ERR_IICSTOP      ;SDA߱λΪ͵ƽ˳
	MOV	TIMETX,#65H             ;Ͷʱ
	LCALL	SENDH_L
        JB      FLAG.0,ERR_IICSTOP      ;ACKźŲ˳.
	MOV	R0,#YEAR
	MOV	R3,#07H
RDTIME1:
	LCALL	RXL_H
	MOV	A,TIMERX
	MOV	@R0,A
	INC	R0
 	DJNZ	R3,RDTIME2              ;һֽݺȷݴ
        JMP     RDTIME3                 ;ΪһֽΪNOACK
RDTIME2:
        CALL    ACK
        JMP     RDTIME1
RDTIME3:
        CALL    NOACK
        LCALL   IICSTOP
        CLR     HOUR.7                  ;Сʱλ24Сʱʱû,12Сʱɾ.
        CLR     SECOND.7                ;λΪ0
RDTIME_RET:
        RET

ERR_IICSTOP:
        LCALL   IICSTOP
        RET

;======================дʵʱʱڲʵʱݼĴ=====================
;ܣ趨ꡢ¡աڡʱ֡дʵʱʱ                  |
;ڣݷꡢ¡աڡʱ֡Ĵ                   |
;ڣNONE                                                               |
;ӰԴAR0R1TXBUF,YEAR,MONTH,DATE,DAY,HOUR,MINUTE,SECOND        |
;==========================================================================
WRITE_TIME:
	LCALL	IICSTART
        JNB     FLAG.1,TIME_WRITE_1
        LJMP    ERR_IICSTOP             ;SDA߱λΪ͵ƽ˳
TIME_WRITE_1:
	MOV	TIMETX,#64H		;дʵʱ1,#64H
	LCALL	SENDH_L
        JNB     FLAG.0,TIME_WRITE_2
        LJMP    ERR_IICSTOP             ;ACKźŲ˳.
TIME_WRITE_2:
	MOV	R0,#YEAR
	MOV	R1,#07H
WRTIME1:MOV	A,@R0
	MOV	TIMETX,A
	LCALL	SENDL_H
	INC	R0
	DJNZ	R1,WRTIME1
	LCALL	IICSTOP
	RET


;============================ACK===========================================
;ܣʱ         ڣNONE             ڣNONE                     |
;ӰԴ                                                               |
;==========================================================================
ACK:    CLR      TIMETEMP.1
        LCALL    BITOUT
        RET

;============================ACK===========================================
;ܣʱ         ڣNONE             ڣNONE                     |
;ӰԴ                                                               |
;==========================================================================
NOACK:  SETB     TIMETEMP.1
        LCALL    BITOUT
        RET

;==============================================================
;ܣMCUIICӿͨʱĴ״̬                                   |
;ڣTIMETEMP.0=ACKλֵ                                                |
;ڣFLAG.0 =                                                   |
;==========================================================================
ACK_ERR:
        JNB     TIMETEMP.0,ACK_ERR_RET  ;ACKźǷ
        SETB    FLAG.0                  ;ACK־λ
ACK_ERR_RET:
        RET
;===============================IIC================================
;ܣʵʱʱӵIIC
;ڣNONE       ڣNONE
;ӰԴNONE
;==========================================================================
IICSTART:
        CLR     FLAG.1
	SETB	SDA
	SETB	SCL
	LCALL	DELAY
        JB      SDA,IIC_SDAHI
        SETB    FLAG.1
IIC_SDAHI:
	CLR	SDA
        LCALL   DELAY
	CLR	SCL
        LCALL    DELAY
        RET
;===============================رIIC================================
;ܣرʵʱʱIIC
;ڣNONE       ڣNONE
;ӰԴNONE
;==========================================================================
IICSTOP:CLR	SDA
	SETB	SCL
	LCALL	DELAY
	SETB	SDA
	LCALL	DELAY
	RET
;============================һֽڣɸλλ================
;ܣMCUһֽڸʵʱʱ,ɸλλ                        |
;ڣݷTIMETX          ڣNONE                              |
;ӰԴAR2TIMETX                                                   |
;==========================================================================
SENDH_L:MOV	A,TIMETX
	MOV	R2,#08H
        CLR     FLAG.0
SENDH_L1:
        MOV	C,ACC.7
        MOV	TIMETEMP.1,C
	LCALL	BITOUT
	RL	A
	DJNZ	R2,SENDH_L1
        LCALL   BITIN
        LCALL   ACK_ERR
        RET
;==========================һֽڣɵλλ==================
;ܣMCUһֽڸʵʱʱ,ɵλλ                        |
;ڣݷTIMETX          ڣNONE                              |
;ӰԴAR2TIMETX                                                   |
;==========================================================================
SENDL_H:MOV	A,TIMETX
	MOV	R2,#08H
        CLR     FLAG.0
SENDL_H1:
        MOV	C,ACC.0
        MOV	TIMETEMP.1,C
        LCALL	BITOUT
	RR	A
	DJNZ	R2,SENDL_H1
        LCALL   BITIN
        LCALL   ACK_ERR
	RET

;=================================һֽ=============================
;ܣMCUIIC߽һֽ,MSBǰ,LSBں                           |
;ڣNONE          ڣݷRXBUF                            |
;ӰԴAR2TIMEBITRXBUF                                          |
;==========================================================================
RXH_L:	MOV	R2,#08H
RXH_L1: LCALL	BITIN
        MOV	C,TIMETEMP.0
        MOV	ACC.7,C
	RLC	A
	DJNZ	R2,RXH_L1
        MOV     TIMERX,A
        RET
;=================================һֽ=============================
;ܣMCUIIC߽һֽ,LSBǰ,MSBں                           |
;ڣNONE          ڣݷRXBUF                            |
;ӰԴAR2TIMEBITRXBUF                                          |
;==========================================================================
RXL_H:	MOV	R2,#08H
RXL_H1: LCALL	BITIN
        MOV	C,TIMETEMP.0
	RRC	A
	DJNZ	R2,RXL_H1
        MOV     TIMERX,A
        RET

;================================ͳһλ================================
;ܣMCUһλʵʱʱ                                          |
;ڣλEEPREM.1       ڣNONE                              |
;ӰԴATIMETEMP                                                    |
;==========================================================================
BITOUT:
        MOV	C,TIMETEMP.1
	MOV	SDA,C
	LCALL	DELAY
	SETB	SCL
	LCALL	DELAY
	CLR	SCL
        LCALL   DELAY
	RET
;=================================һλ===============================
;ܣMCUʵʱʱӽһλ                                            |
;ڣNONE       ڣλTIMETEMP.0                            |
;ӰԴATIMETEMP                                                    |
;==========================================================================
BITIN:
        SETB	SDA
        SETB    SCL
	LCALL	DELAY
	MOV	C,SDA
        MOV	TIMETEMP.0,C
	CLR	SCL
        CLR     SDA
        LCALL   DELAY
	RET

;============================ʱӳ==================================
;ܣʱ         ڣNONE             ڣNONE                     |
;ӰԴR7,PSW                                                         |
;==========================================================================
DELAY:	MOV	R7,#05H
DELAY1:	NOP
	DJNZ	R7,DELAY1
	RET
LONGDELAY:                     ;DELAY 300MS
        MOV     R6,#240
LD0:    MOV     R7,#250        ;5*250*240
LD1:    NOP
        NOP
        NOP
        DJNZ    R7,LD1
        DJNZ    R6,LD0
        RET


;============================д״̬Ĵ==============================
;ܣ/дʵʱʱ״̬Ĵ                              |
;ڣNONE           ڣNONE                                          |
;ӰԴ ATIMETX                                                     |
;==========================================================================
TIMESTATUS_INT12:
        LCALL   IICSTART
        JNB     FLAG.1,TIME_SETMODE_1
        LJMP    ERR_IICSTOP             ;SDA߱λΪ͵ƽ˳
TIME_SETMODE_1:
	MOV	TIMETX,#62H             ;дʱ״̬Ĵ
	LCALL	SENDH_L
        JNB     FLAG.0,TIME_SETMODE_2
        LJMP    ERR_IICSTOP             ;ACKźŲ˳.
TIME_SETMODE_2:
	MOV	TIMETX,#40H             ;24Сʱƣ
	LCALL	SENDL_H		        ;ر/INT1/INT2ŵ
        LCALL   IICSTOP                 ;
        RET
        END








